Magellan Linux

Diff of /tags/installer-simple-0_4_90_20140703_1/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2321 by niro, Fri Jan 3 13:15:44 2014 UTC revision 2476 by niro, Wed Jan 8 09:15:14 2014 UTC
# Line 1  Line 1 
1  #!/bin/sh  #!/bin/bash
2    # $Id$
3  #  #
4  # $Header: /home/cvsd/alx-cvs/alx-src/alxinstall-ng/bin/alxinstall-ng.sh,v 1.15 2008-06-28 00:37:45 niro Exp $  # Simple Installation Script
5  #  # merged from alxinstall-ng and mcore-installer
 # AutoSta_LX Installation Script  
6  #  #
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
 # <rogalla@augusta-bochum.de>  
 #  
 #  
 # Install Navigation Gui  
8  #  #
9    
10  #images: (get ${CDIMAGENAME})  # setup locales
11  source /mnt/cdrom/system/images.conf  TEXTDOMAIN=installer
12    LC_MESSAGES=C
13    
14  #Includes  # include dir
15  source /usr/lib/alxinstall-ng/functions/findhdd.sh > /dev/null  INSTALLER_LIBDIR="%LIBDIR%"
 ### bugfix ###############################  
 cdromdev="$(echo ${cdromdev} | sed 's/ //')"  
 ########################################  
16    
17  ### System/Config Version  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
18  VERSION="%VERSIONTAG%"  # -> now in images.conf
19  TITLE="alxinstall-ng - ${VERSION}"  CURRENTLINE=0
20    
21  CDPATH="/mnt/cdrom"  die()
22  INSTALLPATH="/mnt/magellan"  {
23     echo "Error: $@"
24     exit 1
25    }
26    
27  ### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1  # load common includes
28    for inc in %SYSCONFDIR%/installer.conf \
29     ${INSTALLER_LIBDIR}/functions/common.sh \
30     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
31     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
32     ${INSTALLER_LIBDIR}/functions/bootloader.sh \
33     ${INSTALLER_LIBDIR}/functions/initrd-tools.sh \
34     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
35    do
36     if [ -e ${inc} ]
37     then
38     source "${inc}"
39     else
40     die "'${inc}' not found"
41     fi
42    done
43    
44    # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
45    # -> now in images.conf
46    CDIMAGENAME=""
47    TOTALLINES=""
48  CURRENTLINE=0  CURRENTLINE=0
49  #TOTALLINES=11072 # -> now in images.conf  if [ -e /mnt/cdrom/system/images.conf ]
50    then
51     source /mnt/cdrom/system/images.conf
52     # check if all required variables are set
53     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
54     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
55    else
56     die "/mnt/cdrom/system/images.conf not found"
57    fi
58    
59  # standard kernel opts  ### System/Config Version
60  KERNELOPTS="quiet video=1024x768"  VERSION="%VERSIONTAG%"
61    TITLE="${DEFAULT_TITLE} - ${VERSION}"
62    
63  # grub options  # some sane defaults
64    CDROOT="${DEFAULT_CDROOT}"
65    INSTALLROOT="${DEFAULT_INSTALLROOT}"
66    KERNELPKG="${DEFAULT_KERNELPKG}"
67    KERNELOPTS="${DEFAULT_KERNELOPTS}"
68  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
69  GRUB2OPTS=""  GRUB2OPTS=""
   
 # fdisk options  
70  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
   
 # default specialdevices  
71  SPECIALDEVICE=""  SPECIALDEVICE=""
72  FORMFACTOR="desktop"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
73    FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
 # target filesystem  
 FORMAT_FILESYSTEM="ext4"  
74    
75  #################################################  #################################################
76  #  DIALOG BOXEN #  #  DIALOG BOXEN #
77  #################################################  #################################################
78    
79  die()  trap_exit()
80    {
81     is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
82     is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
83     is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
84     is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
85     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
86    
87     echo $"Installation aborted."
88     exit 1
89    }
90    
91    dialog_die()
92  {  {
93   ERROR=$1   ERROR="$1"
94   RETVAL=$?   RETVAL="$?"
95   dialog_install_failure   dialog_install_failure
96   exit 1   exit 1
97  }  }
98    
99  dialog_warning()  dialog_warning()
100  {  {
101   dialog \   local retval
102   --backtitle "${TITLE}" \  
103   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
104   --defaultno \   retval=$?
105   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
106   then   then
107   clear   clear
108   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
109   exit 1   exit 1
110   fi   fi
111  }  }
112    
113  dialog_setup_hdd_info()  task_setup_system_menu()
 {  
  local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 1 Partition an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_auto()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nAchtung!\n\  
  Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81  
 }  
   
 dialog_setup_system_menu()  
114  {  {
115   local i   local mode
116     local retval
117    
118   i=$(dialog \   mode="$(dialog_setup_system_menu)"
119   --backtitle "${TITLE}" \   retval=$?
120   --title "[ Festplatten Partitionierung ]" \   [[ ${retval} -eq 1 ]] && return 1
121   --cancel-label "Abbrechen" \   if [[ ${retval} -eq 0 ]]
  --ok-label "Weiter" \  
  --stdout \  
  --colors \  
  --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \  
  "1" "Automatisches Setup (Empfohlen)" \  
  "" "" \  
  "" "\Z1Experten Modi:\Zn" \  
  "2" "Normale IDE-Disk (Manuell)" \  
  "3" "Flash-Speicher (Manuell)")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
122   then   then
123   case "${i}" in   case "${mode}" in
124   "1") run_install_auto ;;   "1") run_install_auto ;;
125           "2") run_install_normal ;;   "2") run_install_normal ;;
126   "3") run_install_flash ;;   "") task_setup_system_menu;;
  "") dialog_setup_system_menu;;  
127   esac   esac
128   fi   fi
129  }  }
130    
131  dialog_hardware_detection()  dialog_hardware_detection()
132  {  {
133   local i   local message
  local hwtmp  
   
  if [ -x $(which mktemp &> /dev/null) ]  
  then  
  hwtmp="$(mktemp)"  
  else  
  hwtmp="/tmp/hwtmp.sh"  
  fi  
134    
135   [[ ! -z ${installdevs} ]] && installdevs=""   run_hardware_detection_disks
136    
137   echo "dialog \\"  > ${hwtmp}   message+=$"Harddrives:\n"
  echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}  
  echo "--ok-label \"Weiter\" \\" >> ${hwtmp}  
  echo "--stdout \\" >> ${hwtmp}  
  echo "--colors \\" >> ${hwtmp}  
  echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}  
  echo " Festplatten:\n \\" >> ${hwtmp}  
138    
139   if [[ ! -z ${scsidisks} ]]   if [[ ! -z ${ALL_DISKS} ]]
140   then   then
141   for i in ${scsidisks}   for i in ${ALL_DISKS}
142   do   do
143   if [[ ${i} != ${cdromdev} ]]   message+="\Z3${i}\Zn "
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
144   done   done
145     message+="\n"
146   fi   fi
147    
148   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
149   then   then
150   for i in ${idedisks}   message+="\n"
151     message+=$"Optical disk drives:\n"
152     for i in ${ALL_CDROMS}
153   do   do
154   if [[ ${i} != ${cdromdev} ]]   message+="\Z3${i}\Zn"
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
155   done   done
156   fi   message+="\n"
   
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
157   fi   fi
158    
159   # other devices   # other devices
160   run_hardware_detection   run_hardware_detection
161   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
162   zotac*) echo " \n\n\n \\Z2Zotac Device erkannt.\\Zn \\" >> ${hwtmp} ;;   zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
163   rangee) echo " \n\n\n \\Z2Rangee Device erkannt.\\Zn \\" >> ${hwtmp} ;;   rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
164   maxdata) echo " \n\n\n \\Z2Maxdata Device erkannt.\\Zn \\" >> ${hwtmp} ;;   maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
165   *) echo " \n\n\n \\ZnStandard Device erkannt.\\Zn \\" >> ${hwtmp} ;;   *) message+=$"\n\ZnCommon device detected.\Zn" ;;
166   esac   esac
167   if [[ ${FORMFACTOR} = laptop ]]   if [[ ${FORMFACTOR} = laptop ]]
168   then   then
169   echo " \n \\ZnFormfactor Laptop, Powersave Modus 'ondemand' wird aktiviert.\\Zn \\" >> ${hwtmp}   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
170   fi   fi
171    
172   echo " \" 14 70" >> ${hwtmp}   messagebox -y 12 -h $"Detected hardware:" "${message}"
  chmod a+x ${hwtmp}  
  ${hwtmp}  
   
  # remove tmp file  
  if [[ -f ${hwtmp} ]]  
  then  
  rm ${hwtmp}  
  fi  
173  }  }
174    
175  dialog_setup_hdd_partitions_manuell()  dialog_setup_hdd_partitions_manual()
176  {  {
177   local i   local i
178     local retval
179    
180   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
181   then   then
182   dialog \   dialog_no_harddrive_found
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
183   exit 1   exit 1
184   else   else
185     HDD=$(dialog_select_target_harddrive)
186   echo "dialog \\" > /tmp/hddtmp.sh   retval=$?
187   echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh   [[ ${retval} -eq 1 ]] && return 1
188   echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh   if [[ ${retval} -eq 0 ]]
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
189   then   then
190   dialog_setup_hdd_info   dialog_setup_hdd_info
191   setup_hdd_partitions_manuell   setup_hdd_partitions_manual
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_manuell_flash()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_flash  
  setup_hdd_partitions_manuell_flash  
192   fi   fi
193   fi   fi
194  }  }
# Line 307  dialog_setup_hdd_partitions_manuell_flas Line 196  dialog_setup_hdd_partitions_manuell_flas
196  dialog_setup_hdd_partitions_auto()  dialog_setup_hdd_partitions_auto()
197  {  {
198   local i   local i
199     local retval
200    
201   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
202   then   then
203   dialog \   dialog_no_harddrive_found
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
204   exit 1   exit 1
205   else   else
206     HDD=$(dialog_select_target_harddrive)
207   echo "dialog \\" > /tmp/hddtmp.sh   retval=$?
208   echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh   [[ ${retval} -eq 1 ]] && return 1
209   echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh   if [[ ${retval} -eq 0 ]]
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
210   then   then
211   dialog_setup_hdd_info_auto   dialog_setup_hdd_info_auto
212   dialog_setup_hdd_create_partitions   dialog_setup_hdd_create_partitions
# Line 343  dialog_setup_hdd_partitions_auto() Line 215  dialog_setup_hdd_partitions_auto()
215   fi   fi
216  }  }
217    
218  dialog_setup_hdd_create_partitions()  install_meter()
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Disk Partitionen ..." 3 70  
 }  
   
 dialog_setup_hdd_format()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Datei-Systeme ..." 3 70  
 }  
   
 dialog_install_settings()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Speichere System-Einstellungen ..." 3 70  
 }  
   
 dialog_install_system_image()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --gauge "Kopiere System-Image ..." 6 80  
 }  
   
 dialog_install_meter()  
219  {  {
220   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
221   do   do
# Line 384  dialog_install_meter() Line 228  dialog_install_meter()
228   return 0   return 0
229  }  }
230    
   
 dialog_install_bootsector()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Schreibe den Bootsektor ..." 3 70  
 }  
   
 dialog_install_successful()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --colors \  
  --msgbox "Die Installation war \Z2erfolgreich\Zn." 5 81  
 }  
   
 dialog_install_failure()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --colors \  
  --msgbox "Die Installation ist \Z1Fehlgeschlagen\Zn.\n\n\  
  Fehler bei ${ERROR}, RetVal: ${RETVAL} \  
  " 10 81  
 }  
   
231  dialog_main()  dialog_main()
232  {  {
233   METHOD=0   local method=0
234     local retval
235    
236   while [[ ${METHOD} -le 2 ]]   while [[ ${method} -le 2 ]]
237   do   do
238   METHOD=$(dialog \   method=$(CANCEL_LABEL=$"Exit" menubox $"Configuration:" \
239   --backtitle "${TITLE}" \   $"1:Install system" \
240   --no-cancel \   $"2:Show detected harddrives" \
241   --ok-label "Weiter" \   $"3:Exit and reboot" \
242   --stdout \   $"4:Exit and drop into a shell")
243   --menu "Konfiguration" 14 70 5 \   retval=$?
244   "1" "AutoSta_LX installieren" \   [[ ${retval} -eq 1 ]] && exit 1
245   "2" "Uebersicht gefundener Laufwerke" \   if [[ ${retval} -eq 0 ]]
  "3" "Beenden und neustarten" \  
  "4" "Beenden und eine Shell starten")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && exit 1  
  if [[ ${RES} -eq 0 ]]  
246   then   then
247   case ${METHOD} in   case ${method} in
248           "1") dialog_setup_system_menu ;;   "1") task_setup_system_menu ;;
249   "2") dialog_hardware_detection ;;   "2") dialog_hardware_detection ;;
250   "3") install_do_reboot ;;   "3") install_do_reboot ;;
251   "4") /bin/bash --login -i ;;   "4") /bin/bash --login -i ;;
# Line 449  run_hardware_detection() Line 263  run_hardware_detection()
263    
264   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
265    
266   # check for special devices/clients:   ## check for special devices/clients:
267   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
268   local removable=0   #local removable=0
269   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
270   then   #then
271   for i in /sys/block/[hs]d*/removable   #for i in /sys/block/[hs]d*/removable
272   do   #do
273   if [[ $(< ${i}) = 1 ]]   #if [[ $(< ${i}) = 1 ]]
274   then   #then
275   removable=1   #removable=1
276   fi   #fi
277   done   #done
278     ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
279   # only add this for grub legacy, grub2 detect these settings on its own  
280   export GRUBLEGACYOPTS="rootdelay=8"   ## only add this for grub legacy, grub2 detect these settings on its own
281   # there are to zotac types in the wild, nvidia based gfx and intel   #export GRUBLEGACYOPTS="rootdelay=8"
282   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   ## there are to zotac types in the wild, nvidia based gfx and intel
283   then   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
284   export SPECIALDEVICE="zotac_nvidia"   #then
285   else   #export SPECIALDEVICE="zotac_nvidia"
286   export SPECIALDEVICE="zotac_intel"   #else
287   fi   #export SPECIALDEVICE="zotac_intel"
288   fi   #fi
289     #fi
290    
291   # check for special devices/clients:   # check for special devices/clients:
292   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 500  run_hardware_detection() Line 315  run_hardware_detection()
315   fi   fi
316  }  }
317    
318  hdd_size_below_256mb()  run_hardware_detection_disks()
319  {  {
320   local hdd="$1"   local bootdev
  local size  
  local retval  
  [[ -z ${hdd} ]] && die "Error: get_hdd_size() no \$hdd given!"  
321    
322   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   # all disks but exclude ramdisks
323   if [[ ${size} -le 257000000 ]]   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
324     # remove the boot device from ALL_DISKS if it was an usbstick
325     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
326   then   then
327   retval="0"   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
328   else   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  retval="1"  
329   fi   fi
330     export ALL_CDROMS="$(get_hwinfo cdrom)"
  return "${retval}"  
331  }  }
332    
333  setup_hdd_partitions_auto()  setup_hdd_partitions_auto()
334  {  {
335   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
336    
337     # sanity check - should not happen
338     if is_mounted --device "${ROOTHDD}"
339     then
340     echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
341     umount "${ROOTHDD}"
342     fi
343    
344   # run this only if FDISKPARTITIONBELOW256MB is not already 1   # run this only if FDISKPARTITIONBELOW256MB is not already 1
345   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
346   then   then
# Line 534  setup_hdd_partitions_auto() Line 353  setup_hdd_partitions_auto()
353   fi   fi
354    
355   ## delete disk   ## delete disk
356   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || die   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
357    
358   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
359   then   then
# Line 580  EOF Line 399  EOF
399   fi   fi
400  }  }
401    
402  setup_hdd_partitions_manuell()  setup_hdd_partitions_manual()
 {  
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
403  {  {
404   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
405     SWAPHDD=""
406   ## hdds partitionieren manuell   BOOTHDD=""
407   cfdisk ${HDD} || die   cfdisk ${HDD} || dialog_die
408  }  }
409    
410  setup_hdd_format()  setup_hdd_format()
411  {  {
412   mkswap ${SWAPHDD} || die   # sanity check - should not happen
413   mke2fs -j -q ${BOOTHDD} || die   if is_mounted --device "${ROOTHDD}"
414   mke2fs -j -q ${ROOTHDD} || die   then
415  }   echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
416     umount "${ROOTHDD}"
417     fi
418    
419  setup_hdd_format_flash()   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
 {  
  mke2fs -j -q ${ROOTHDD} || die  
420  }  }
421    
422  install_mount_rootfs()  install_mount_rootfs()
423  {  {
424   swapon ${SWAPHDD} || die   is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"
425   mount ${ROOTHDD} ${INSTALLPATH} || die   install -d ${INSTALLROOT}/boot || dialog_die
  install -d ${INSTALLPATH}/boot || die  
  mount ${BOOTHDD} ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
 }  
   
 install_mount_rootfs_flash()  
 {  
  mount ${ROOTHDD} ${INSTALLPATH} || die  
  install -d ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
426  }  }
427    
428  install_system_image()  install_system_image()
429  {  {
430   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}   pushd ${INSTALLROOT} > /dev/null
431     tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
432     popd > /dev/null
433  }  }
434    
435  install_bootsector_chroot()  disabled_install_bootsector_chroot()
436  {  {
437   local my_roothdd   local my_roothdd
438   local grubconf=${INSTALLPATH}/boot/grub/grub.conf   local grubconf="${INSTALLROOT}/boot/grub/grub.conf"
439   local grub2conf=/boot/grub/grub.cfg   local grub2conf="/boot/grub/grub.cfg"
440    
441   # check for grub2   # check for grub2
442   if [[ -f ${INSTALLPATH}/sbin/grub-mkconfig ]]   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
443   then   then
444   # needed by grub-mkconfig on the first run   # needed by grub-mkconfig on the first run
445   if [[ ! -f ${INSTALLPATH}/boot/grub/video.lst ]]   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
446   then   then
447   install -m0644 ${INSTALLPATH}/lib/grub/*/video.lst ${INSTALLPATH}/boot/grub/video.lst || die   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
448   fi   fi
449    
450   # set kernelopts   # set kernelopts
451   if [[ -f ${INSTALLPATH}/etc/conf.d/grub ]]   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
452   then   then
453   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLPATH}/etc/conf.d/grub || die   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
454   else   else
455   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLPATH}/etc/conf.d/grub || die   CONFIG="${INSTALLROOT}/etc/conf.d/grub"
456   fi   clearconfig
457   echo 'grub-mkdevicemap' > ${INSTALLPATH}/root/.installrc || die   addconfig "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\""
458   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   fi
459   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   CONFIG="${INSTALLROOT}/root/.installrc"
460   echo "exit 0" >> ${INSTALLPATH}/root/.installrc || die   clearconfig
461     # only grub 1.99
462     addconfig 'type -P grub-mkdevicemap && grub-mkdevicemap'
463     addconfig "grub-install --no-floppy ${HDD} &> /dev/null"
464     addconfig "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null"
465     addconfig "exit 0"
466    
467   # grub-legacy   # grub-legacy
468   else   else
469   ### grubconf schreiben   source ${INSTALLROOT}/boot/kernelversion
  source ${INSTALLPATH}/boot/kernelversion  
470    
471   #for alx only   if [ -e ${INSTALLROOT}/etc/alx_version ]
  if [ -e ${INSTALLPATH}/etc/alx_version ]  
472   then   then
473   OLD_ALXVER="${ALXVER}"   OLD_ALXVER="${ALXVER}"
474   source ${INSTALLPATH}/etc/alx_version   source ${INSTALLROOT}/etc/alx_version
475   KRNVER="ALX-${ALXVER}"   KRNVER="ALX-${ALXVER}"
476   ALXVER="${OLD_ALXVER}"   ALXVER="${OLD_ALXVER}"
477   fi   fi
# Line 677  install_bootsector_chroot() Line 481  install_bootsector_chroot()
481   [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"   [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"
482    
483   # uuid support   # uuid support
484   if is_uuid_supported   my_roothdd="UUID=$(get_uuid ${ROOTHDD})"
  then  
  my_roothdd="UUID=$(get_uuid ${ROOTHDD})"  
  else  
  my_roothdd="${ROOTHDD}"  
  fi  
485    
486   : > ${grubconf} || die   CONFIG="${grubconf}"
487   echo "default 0" >> ${grubconf} || die   clearconfig
488   echo "timeout 3" >> ${grubconf} || die   addconfig "default 0"
489     addconfig "timeout 3"
490   # using current root password   # using current root password
491   echo "password --md5 $(cat ${INSTALLPATH}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || die   addconfig "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"
492    
493   echo  >> ${grubconf} || die   addconfig
494   echo "# normal boot" >> ${grubconf} || die   addconfig "# normal boot"
495   echo "title ${KRNVER}" >> ${grubconf} || die   addconfig "title ${KRNVER}"
496   echo "root (hd0,0)" >> ${grubconf} || die   addconfig "root (hd0,0)"
497   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || die   addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}"
498   if is_initrd_supported   if is_initrd_supported
499   then   then
500   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   addconfig "initrd /boot/${KRNINITRD}"
501   fi   fi
502    
503   echo >> ${grubconf} || die   addconfig
504   echo "# admin boot" >> ${grubconf} || die   addconfig "# admin boot"
505   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || die   addconfig "title ${KRNVER} - Re-run hardware-detection"
506   echo "lock"  >> ${grubconf} || die   addconfig "lock"
507   echo "root (hd0,0)" >> ${grubconf} || die   addconfig "root (hd0,0)"
508   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || die   addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection"
509   if is_initrd_supported   if is_initrd_supported
510   then   then
511   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   addconfig "initrd /boot/${KRNINITRD}"
512   fi   fi
513    
514   echo >> ${grubconf} || die   addconfig
515   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || die   addconfig "title ${KRNVER} - Reset *all* local settings"
516   echo "lock"  >> ${grubconf} || die   addconfig "lock"
517   echo "root (hd0,0)" >> ${grubconf} || die   addconfig "root (hd0,0)"
518   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || die   addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings"
519   if is_initrd_supported   if is_initrd_supported
520   then   then
521   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   addconfig "initrd /boot/${KRNINITRD}"
522   fi   fi
523    
524   # bootsector schreiben chrooted schreiben (lfs/magellan)   # bootsector schreiben chrooted schreiben (lfs/magellan)
525   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
526  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
527  root (hd0,0)  root (hd0,0)
528  setup (hd0)  setup (hd0)
# Line 732  exit 0 Line 532  exit 0
532  CHROOTEOF  CHROOTEOF
533   fi   fi
534    
535   ## enters chroot   # run installrc
536   mount -t proc proc ${INSTALLPATH}/proc   chrooted /bin/bash --rcfile /root/.installrc -i
537   mount -t sysfs sysfs ${INSTALLPATH}/sys   rm ${INSTALLROOT}/root/.installrc
  mount -o bind /dev ${INSTALLPATH}/dev  
  chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i  
  umount ${INSTALLPATH}/proc  
  umount ${INSTALLPATH}/sys  
  umount ${INSTALLPATH}/dev  
  rm ${INSTALLPATH}/root/.installrc  
 }  
   
 is_initrd_supported()  
 {  
  # only generate initrds if the cmd exists  
  [[ -x ${INSTALLPATH}/sbin/mkinitrd ]] && return 0  
  return 1  
538  }  }
539    
540  install_initrd_chroot()  disabled_install_initrd_chroot()
541  {  {
542   # only generate initrds if the cmd exists   # only generate initrds if the cmd exists
543   is_initrd_supported || return 0   is_initrd_supported || return 0
# Line 777  install_initrd_chroot() Line 564  install_initrd_chroot()
564   fi   fi
565    
566   # install an appropriate uvesafb.conf   # install an appropriate uvesafb.conf
567   install -d ${INSTALLPATH}/etc/modprobe.d || die   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
568   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLPATH}/etc/modprobe.d/uvesafb.conf || die   CONFIG="${INSTALLROOT}/etc/modprobe.d/uvesafb.conf"
569     clearconfig
570     addconfig "options uvesafb mode_option=1024x768-32@60 scroll=ywrap"
571    
572   # install an appropriate viafb.conf   # install an appropriate viafb.conf
573   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLPATH}/etc/modprobe.d/viafb.conf || die   CONFIG="${INSTALLROOT}/etc/modprobe.d/viafb.conf"
574     clearconfig
575     addconfig "options viafb viafb_mode=1024x768 viafb_refresh=60"
576    
577   # install an appropriate i810fb.conf   # install an appropriate i810fb.conf
578   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLPATH}/etc/modprobe.d/i810fb.conf || die   CONFIG="${INSTALLROOT}/etc/modprobe.d/i810fb.conf"
579     clearconfig
580     addconfig "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"
581    
582   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
583  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
584  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
585  exit 0  exit 0
586  CHROOTEOF  CHROOTEOF
587    
588   ## enters chroot   # run installrc
589   mount -t proc proc ${INSTALLPATH}/proc   chrooted /bin/bash --rcfile /root/.installrc -i
590   mount -t sysfs sysfs ${INSTALLPATH}/sys   rm ${INSTALLROOT}/root/.installrc
  mount -o bind /dev ${INSTALLPATH}/dev  
  chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i  
  umount ${INSTALLPATH}/proc  
  umount ${INSTALLPATH}/sys  
  umount ${INSTALLPATH}/dev  
  rm ${INSTALLPATH}/root/.installrc  
 }  
   
 is_uuid_supported()  
 {  
  if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]  
  then  
  # only detect uuids if supported  
  if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]  
  then  
  return 0  
  fi  
  fi  
   
  return 1  
 }  
   
 get_uuid()  
 {  
  local UUID  
  local SEC_TYPE  
  local TYPE  
   
  local dev="$1"  
  [[ -z ${dev} ]] && die "no dev given"  
   
  # check if given device is already an UUID  
  if [[ ${dev/UUID=/}x != ${dev}x ]]  
  then  
  eval "${dev}"  
  else  
  eval $(busybox.mkinitrd blkid ${dev} | grep "${dev}:" | sed 's/.*:\ //')  
  fi  
  echo "${UUID}"  
591  }  }
592    
593  install_system_settings()  install_system_settings()
594  {  {
595   # schreibe fstab   local CONFIG
596   if is_uuid_supported  
597   then   # write fstab
598   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   CONFIG="${INSTALLROOT}/etc/fstab"
599   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die   clearconfig
600   else   addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"
601   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
602   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
  fi  
  # not needed busybox loads all with swapon -a, even if not mentioned in fstab  
  #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
603    
604   # install network config skeleton   # install network config skeleton
605   install -m0644 ${INSTALLPATH}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLPATH}/etc/conf.d/ || die   CONFIG="${INSTALLROOT}/etc/conf.d/net.eth0"
606     clearconfig
607     addconfig 'ONBOOT="yes"'
608     addconfig 'NETWORKING="dhcp"'
609    
610   # intel framebufer quirk   # intel framebuffer quirk
611   if [[ -e /proc/fb ]]   if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]
612   then   then
613   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   if [ -e /proc/fb ]
614   then   then
615   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
  if [[ ${fbdev} != 0 ]]  
616   then   then
617   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLPATH}/etc/splash/splash.conf || die   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
618     if [[ ${fbdev} != 0 ]]
619     then
620     sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
621     fi
622   fi   fi
623   fi   fi
624   fi   fi
625  }  }
626    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
 }  
   
627  install_umount_rootfs()  install_umount_rootfs()
628  {  {
629   cd /   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
630   umount ${INSTALLPATH}/boot || die   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
  umount ${INSTALLPATH} || die  
  swapoff ${SWAPHDD} || die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLPATH} || die  
631  }  }
632    
633  install_do_reboot()  install_do_reboot()
# Line 909  run_install_normal() Line 643  run_install_normal()
643  {  {
644   dialog_hardware_detection   dialog_hardware_detection
645    
646   dialog_setup_hdd_partitions_manuell   dialog_setup_hdd_partitions_manual
647   dialog_setup_hdd_format   dialog_setup_hdd_format
648   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
649   install_mount_rootfs   install_mount_rootfs
650   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
651    
652   dialog_install_settings   dialog_install_settings
653   sleep 1   sleep 1
654   install_system_settings   install_system_settings
655   install_initrd_chroot   if is_initrd_supported
656     then
657     dialog_install_initrd
658     initrd_config
659     initrd_install
660     fi
661    
662   dialog_install_bootsector   dialog_install_bootsector
663   install_bootsector_chroot   bootloader_config
664     bootloader_install
665    
666   install_umount_rootfs   install_umount_rootfs
667   dialog_install_successful   dialog_install_successful
668  }  }
669    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
670  run_install_auto()  run_install_auto()
671  {  {
672   dialog_hardware_detection   dialog_hardware_detection
673    
674   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
675   dialog_setup_hdd_format   dialog_setup_hdd_format
676   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
677   install_mount_rootfs_flash   install_mount_rootfs
678   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
679    
680   dialog_install_settings   dialog_install_settings
681   sleep 1   sleep 1
682   install_system_settings_flash   install_system_settings
683   install_initrd_chroot   if is_initrd_supported
684     then
685     dialog_install_initrd
686     initrd_config
687     initrd_install
688     fi
689    
690   dialog_install_bootsector   dialog_install_bootsector
691   install_bootsector_chroot   bootloader_config
692     bootloader_install
693    
694   install_umount_rootfs_flash   install_umount_rootfs
695   dialog_install_successful   dialog_install_successful
696  }  }
697    
698    # set some proper traps
699    trap "trap_exit" SIGINT SIGQUIT
700    
701  dialog_main  dialog_main
702    
703  exit 0  exit 0

Legend:
Removed from v.2321  
changed lines
  Added in v.2476